poj 3126 Prime Path

简介:
Prime Path
Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 14374   Accepted: 8112

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

Source

Northwestern Europe 2006


题目大意:

就是给你两个数 a 和 b,让你把 a 变成 b最少需要几步(每次变化 a 与 b 都是素数) 


解题思路:

首先判断一下是不是素数,然后枚举个位十位百位和千位,用bfs搜索:


上代码


/*
2015 - 09 - 09


Author: ITAK


Motto:
今日的我要超越昨日的我,明日的我要胜过今日的我,
以创作出更好的代码为目标,不断地超越自己。
*/
#include <iostream>
#include <cstdio>
#include <cstring>
#include <queue>

using namespace std;

const int maxn = 1e4;
const int Max = 15000;

struct node
{
    int prime;
    int step;
}q[Max];

bool vis[Max];
int a, b;

bool isprime(int data)
{
    if(data==2 || data==3)
        return 1;
    if(data<=1 || data%2==0)
        return 0;
    else if(data > 3)
    for(int i=3; i*i<=data; i+=2)
        if(!(data%i))
        return 0;
    return 1;
}

void bfs()
{
    int head, tail;
    head = tail = 0;
    q[head].prime = a;
    q[tail++].step = 0;
    vis[a] = 1;
    while(head < tail)
    {
        node x = q[head++];
        if(x.prime == b)
        {
            cout<<x.step<<endl;
            return;
        }
        int numg = x.prime%10;///个位
        int nums = (x.prime/10)%10;///十位
        ///分别枚举个位 十位 百位 千位
        for(int i=1; i<=9; i+=2)///个位数是偶数肯定不是素数
        {
            int dy = (x.prime/10)*10+i;
            if(dy!=x.prime && !vis[dy] && isprime(dy))
            {
                vis[dy] = 1;
                q[tail].prime = dy;
                q[tail++].step = x.step+1;
            }
        }

        for(int i=0; i<=9; i++)
        {
            int dy = (x.prime/100)*100+i*10+numg;
            if(dy!=x.prime && !vis[dy] && isprime(dy))
            {
                vis[dy] = 1;
                q[tail].prime = dy;
                q[tail++].step = x.step+1;
            }
        }

        for(int i=0; i<=9; i++)
        {
            int dy = (x.prime/1000)*1000+i*100+nums*10+numg;
            if(dy!=x.prime && !vis[dy] && isprime(dy))
            {
                vis[dy] = 1;
                q[tail].prime = dy;
                q[tail++].step = x.step+1;
            }
        }

        for(int i=1; i<=9; i++)///千位必须大于0
        {
            int dy = x.prime%1000+1000*i;
            if(dy!=x.prime && !vis[dy] && isprime(dy))
            {
                vis[dy] = 1;
                q[tail].prime = dy;
                q[tail++].step = x.step+1;
            }
        }
    }

    puts("Impossible");
    return;
}
int main()
{
    int t;
    scanf("%d",&t);
    while(t--)
    {
        cin>>a>>b;
        memset(vis, 0, sizeof(vis));
        bfs();
    }
    return 0;
}


目录
相关文章
|
8月前
UVa11679 - Sub-prime
UVa11679 - Sub-prime
34 0
POJ-2389,Bull Math(大数乘法)
POJ-2389,Bull Math(大数乘法)
POJ 1844 Sum
POJ 1844 Sum
80 0
|
机器学习/深度学习
POJ 1775 (ZOJ 2358) Sum of Factorials
POJ 1775 (ZOJ 2358) Sum of Factorials
122 0
|
安全
D-POJ-3126 Prime Path
Description The ministers of the cabinet were quite upset by the message from the Chief of...
1108 0
|
存储 人工智能 算法
HDU 1024 Max Sum Plus Plus【动态规划求最大M子段和详解 】
Max Sum Plus Plus Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 29942    Accepted Submissio...
2361 0
|
人工智能 Java
HDU 1003 Max Sum【动态规划求最大子序列和详解 】
Max Sum Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 250714    Accepted Submission(s): 593...
1251 0
|
人工智能 Java
POJ 1844 Sum
Description Consider the natural numbers from 1 to N. By associating to each number a sign (+ or -) and calculating the value of this expression we obtain a sum S.
797 0
|
人工智能 机器学习/深度学习
POJ 1775 (ZOJ 2358) Sum of Factorials
Description John von Neumann, b. Dec. 28, 1903, d. Feb. 8, 1957, was a Hungarian-American mathematician who made important contributions t...
1111 0